<?php
namespace Faturamento\Repositories;

class Sistproplinp extends \Doctrine\ORM\EntityRepository
{
    public function sistemasLinhaProduto($proposta, $versao, $cdlinpprop){
        $sql = "SELECT SP.NRPROPOSFAS, SP.NRVERPROPFAS, SP.CDLINPPROP,
                       SP.CDSISTEMA  , SI.NMSISTEMA, SI.IDTECNOSIST,
                       PC.CDPROCOMERCI, PC.NMPROCOMERCI, SI.SGSISTEMA, 
                       SP.NRORG, SP.DTINCLUSAO
                FROM
                   SISTPROPLINP SP, SISTEMA SI, PROPOSTALINP PL, PROCOMERCI PC
                WHERE
                   (SP.NRPROPOSFAS  = :P_NRPROPOSFAS ) AND
                   (SP.NRVERPROPFAS = :P_NRVERPROPFAS) AND
                   (SP.CDLINPPROP   = :P_CDLINPPROP  ) AND
                   (SP.CDSISTEMA    = SI.CDSISTEMA   ) AND
                   (SP.NRPROPOSFAS  = PL.NRPROPOSFAS ) AND
                   (SP.NRVERPROPFAS = PL.NRVERPROPFAS) AND
                   (SP.CDLINPPROP   = PL.CDLINPPROP  ) AND
                   (SI.CDPROCOMERCI = PC.CDPROCOMERCI)
                ORDER BY
                   SP.CDSISTEMA";

        $params = array(
            "P_NRPROPOSFAS"   => $proposta,
            "P_NRVERPROPFAS"   => $versao,
            "P_CDLINPPROP"   => $cdlinpprop,
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }
    
    public function consultaQtdSistemasLinhaProduto($proposta, $versao, $cdlinpprop){
        $sql = "SELECT COUNT(*) AS QTDE_SISTEMAS
                   FROM SISTPROPLINP
                  WHERE NRPROPOSFAS  = :P_NRPROPOSFAS
                    AND NRVERPROPFAS = :P_NRVERPROPFAS
                    AND CDLINPPROP   = :P_CDLINPPROP";

        $params = array(
            "P_NRPROPOSFAS"  => $proposta,
            "P_NRVERPROPFAS" => $versao,
            "P_CDLINPPROP"   => $cdlinpprop
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }

    public function verificaLinhaProdIgual($params)
    {
        $sql = "SELECT CDCLIENTE, NMFANTCLIE, IDTIPLINPC, NRUSUALINPC, IDAMBLINPC, IDLPROCLINPC, IDMPROCLINPC, CDSISTEMAS, COUNT(*) QTLINHAPROD
                  FROM (SELECT CDCLIENTE, NMFANTCLIE, NMLINPCLIE, IDTIPLINPC, NRUSUALINPC, IDAMBLINPC, IDLPROCLINPC, IDMPROCLINPC,
                               RTRIM(
                               MAX(DECODE(NRCONTADOR, 01, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 02, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 03, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 04, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 05, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 06, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 07, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 08, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 09, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 10, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 11, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 12, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 13, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 14, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 15, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 16, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 17, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 18, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 19, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 20, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 21, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 22, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 23, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 24, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 25, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 26, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 27, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 28, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 29, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 30, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 31, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 32, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 33, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 34, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 35, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 36, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 37, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 38, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 39, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 40, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 41, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 42, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 43, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 44, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 45, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 46, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 47, CDSISTEMA, ''))||' '||MAX(DECODE(NRCONTADOR, 48, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 49, CDSISTEMA, ''))||' '||
                               MAX(DECODE(NRCONTADOR, 50, CDSISTEMA, ''))) CDSISTEMAS
                          FROM (SELECT LIN.CDCLIENTE, CLI.NMFANTCLIE, LIN.NMLINPCLIE, LIN.IDTIPLINPC,
                                       LIN.NRUSUALINPC, LIN.IDAMBLINPC, LIN.IDLPROCLINPC, LIN.IDMPROCLINPC, LIN.CDLINPCLIE,
                                       SUM(1) OVER (PARTITION BY LIN.CDCLIENTE, CLI.NMFANTCLIE, LIN.NMLINPCLIE, LIN.IDTIPLINPC,
                                                                 LIN.NRUSUALINPC, LIN.IDAMBLINPC, LIN.IDLPROCLINPC, LIN.IDMPROCLINPC,
                                                                 LIN.CDLINPCLIE
                                                        ORDER BY LIN.CDCLIENTE, LIN.NMLINPCLIE, LIN.CDLINPCLIE, SIS.CDSISTEMA
                                                         ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCONTADOR,
                                       SIS.CDSISTEMA
                                  FROM SISTCONTLINP SIS, CLIENTE CLI, CONTRATOLINP LIN
                                 WHERE LIN.CDCLIENTE = :CDCLIENTE
                                   AND CLI.CDCLIENTE = LIN.CDCLIENTE
                                   AND LIN.DTCONTLINPRESC IS NULL
                                   AND SIS.CDCLIENTE  = LIN.CDCLIENTE
                                   AND SIS.CDLINPCLIE = LIN.CDLINPCLIE
                                UNION ALL
                                SELECT PRO.CDCLIENTE, CLI.NMFANTCLIE, LIN.NMLINPPROP, LIN.IDTIPLINPP,
                                       LIN.NRUSUALINPP, LIN.IDAMBLINPP, LIN.IDLPROCLINPP, LIN.IDMPROCLINPP, LIN.CDLINPPROP,
                                       SUM(1) OVER (PARTITION BY PRO.CDCLIENTE, CLI.NMFANTCLIE, LIN.NMLINPPROP, LIN.IDTIPLINPP,
                                                                 LIN.NRUSUALINPP, LIN.IDAMBLINPP, LIN.IDLPROCLINPP, LIN.IDMPROCLINPP,
                                                                 LIN.CDLINPPROP
                                                        ORDER BY PRO.CDCLIENTE, LIN.NMLINPPROP, LIN.CDLINPPROP, SIS.CDSISTEMA
                                                         ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCONTADOR,
                                       SIS.CDSISTEMA
                                  FROM SISTPROPLINP SIS, CLIENTE CLI, PROPOSTAFAS PRO, PROPOSTALINP LIN
                                 WHERE LIN.NRPROPOSFAS  = :NRPROPOSFAS
                                   AND LIN.NRVERPROPFAS = :NRVERPROPFAS
                                   AND LIN.CDLINPPROP  <> :CDLINPPROP
                                   AND PRO.NRPROPOSFAS  = LIN.NRPROPOSFAS
                                   AND PRO.NRVERPROPFAS = LIN.NRVERPROPFAS
                                   AND PRO.CDCLIENTE    = :CDCLIENTE
                                   AND CLI.CDCLIENTE    = PRO.CDCLIENTE
                                   AND SIS.NRPROPOSFAS  = LIN.NRPROPOSFAS
                                   AND SIS.NRVERPROPFAS = LIN.NRVERPROPFAS
                                   AND SIS.CDLINPPROP   = LIN.CDLINPPROP)
                         GROUP BY CDCLIENTE, NMFANTCLIE, NMLINPCLIE, IDTIPLINPC, NRUSUALINPC, IDAMBLINPC, IDLPROCLINPC, IDMPROCLINPC, CDLINPCLIE
                         ORDER BY CDCLIENTE, NMLINPCLIE)
                 WHERE IDTIPLINPC   = :IDTIPLINPC
                   AND NRUSUALINPC  = :NRUSUALINPC
                   AND IDAMBLINPC   = :IDAMBLINPC
                   AND IDLPROCLINPC = :IDLPROCLINPC
                   AND IDMPROCLINPC = :IDMPROCLINPC
                   AND CDSISTEMAS   = :CDSISTEMAS
              GROUP BY CDCLIENTE, NMFANTCLIE, IDTIPLINPC, NRUSUALINPC, IDAMBLINPC, IDLPROCLINPC, IDMPROCLINPC, CDSISTEMAS";

        $params = array(
            "CDCLIENTE"    => $params['CDCLIENTE'],
            "NRPROPOSFAS"  => $params['NRPROPOSFAS'],
            "NRVERPROPFAS" => $params['NRVERPROPFAS'],
            "CDLINPPROP"   => $params['CDLINPPROP'],
            "IDTIPLINPC"   => $params['IDTIPLINPC'],
            "NRUSUALINPC"  => $params['NRUSUALINPC'],
            "IDAMBLINPC"   => $params['IDAMBLINPC'],
            "IDLPROCLINPC" => $params['IDLPROCLINPC'],
            "IDMPROCLINPC" => $params['IDMPROCLINPC'],
            "CDSISTEMAS"   => $params['CDSISTEMAS']
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }
}