<?php
/**
 * Created by JetBrains PhpStorm.
 * User: matheussilva
 * Date: 04/10/13
 * Time: 14:30
 * To change this template use File | Settings | File Templates.
 */
namespace Financeiro\Logic\ContasPagar\BoletoPagar\Exception;

class Exception extends \Geral\Logic\Exception{
    private $mensagem;

    public function __construct($mensagem,$message = "", $code = 0, \Exception $previous = null){
        parent::__construct($message, $code, $previous);
        $this->mensagem = $mensagem;
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName(){
        return $this->mensagem;
    }

    /**
     * Retorna Exceção com a mensagem "Os boletos devem ser do mesmo fornecedor."
     * @throws Exception
     */
    public static function fornecedoresDiferentes(){
        throw new self("msg_pbi00017_fornecedoresDiferentes");
    }

    /**
     * Retorna Exceção com a mensagem "Os boletos devem ser da mesma empresa."
     * @throws Exception
     */
    public static function empresasDiferentes(){
        throw new self("msg_pbi00017_empresasDiferentes");
    }
}