/**
 * Recebe a data do cardpio de origem e um servio. Cria uma cpia do cardpio do servio nos dias indicados no mapa.
 * TRANSAO AUTONOMA: Se ocorrer algum erro, registra na lista de erros e d ROLLBACK. Se no deu erro, d um COMMIT.
 * @param {Date} P_DTCARDORI Data do cardpio de origem
 * @param {Varchar2} P_CDFILIAL Cdigo da filial
 * @param {Varchar2} P_CDSERVFILI Cdigo do servio
 * @param {Date} P_DTCARDDEST Data do cardpio de destino
 * @param {Varchar2} P_CDOPERADOR Cdigo do operador logado 
 * @param {Number} P_NRORG Nmero da organizao
 */
CREATE OR REPLACE PROCEDURE REGISTRA_LOG_REPLICACARDPLA
(
	P_DTCARDORI IN DATE,
	P_CDFILIAL IN VARCHAR2,
	P_CDSERVFILI IN VARCHAR2,
	P_DTCARDDEST IN DATE,
	P_IDERRO IN VARCHAR2,
	P_CDOPERADOR IN VARCHAR2,	
	P_NRORG IN NUMBER
)
AS	
   V_NRLOGREPLICACARDPLA NUMBER;
   PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
	V_NRLOGREPLICACARDPLA := TO_NUMBER(RETORNA_NOVO_CODIGO('LOGREPLICACARDPLA', 1));
   INSERT INTO LOGREPLICACARDPLA
   (
   NRLOGREPLICACARDPLA, DTREPLICACAO, CDFILIAL, CDSERVFILI, 
   DTMESORIGEM, DTMESDEST, IDERRO, 
   NRORG, NRORGINCLUSAO, NRORGULTATU, 
   DTINCLUSAO, DTULTATU, 
   CDOPERINCLUSAO, CDOPERULTATU
   )
   VALUES
   (
   V_NRLOGREPLICACARDPLA, TRUNC(SYSDATE), P_CDFILIAL, P_CDSERVFILI,
   P_DTCARDORI, P_DTCARDDEST, P_IDERRO, 
   P_NRORG, P_NRORG, P_NRORG, 
   SYSDATE, SYSDATE, 
   P_CDOPERADOR, P_CDOPERADOR
   );

   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('REGISTRA_LOG_REPLICACARDPLA','6.29.xxx'); END;
/