<?php
namespace Teknisa\Model\Teknisa\Repositories;
use OrganizationsManagement\Util\Utilities;

class Soliserv extends \Doctrine\ORM\EntityRepository {

    public function findFileSendingSolicitationDelphi($filters, $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT SEA.NRSOLISERV AS NRSOLI_ENV_ARQ, SEA.DSREFESOLI AS DSREFE_ENV_ARQ, CEA.NMFANTCLIE AS NMCLIE_ENV_ARQ,
                       DECODE(ORG.IDORGSAAS, 'H', 'Hosting', 'S', 'SaaS', 'N', 'Local (On premisse)', 'Indefinido') AS IDORG_HOSPEDAGEM,
                       PGE.NMPRODUTO AS VERSAO_ENV_ARQ, PCE.CDPRODUTO AS CDPROD_ENV_ARQ, PCE.NMPRODUTO AS PRODUTO_ENV_ARQ, 
                       PEA.STRUCTURE AS STRUCT_ENV_ARQ, LEA.DTALFASETRAM AS DTULTTRAM_ENV_ARQ, FEA.DSSTFASETRAM AS DSFASE_ENV_ARQ,
                       SOR.NRSOLISERV AS NRSOLI_ORIG, SOR.DSREFESOLI AS DSREFE_ORIG, COR.NMFANTCLIE AS NMCLIE_ORIG, PGO.NMPRODUTO AS VERSAO_ORIG, 
                       PCO.NMPRODUTO AS PRODUTO_ORIG, FSO.DSSTFASETRAM AS DSFASETRAM_ORIG,
                       CASE WHEN SOR.NRSOLISERV IS NOT NULL 
                             AND SEA.NRSOLISERV <> SOR.NRSOLISERV 
                             AND SEA.CDPRODGRUP = SOR.CDPRODGRUP 
                             AND PCE.NMPRODUTO = PCO.NMPRODUTO 
                       THEN 1 
                       ELSE 0 
                       END AS IDORIG_N_HOMOL,
                       CASE WHEN SOR.NRSOLISERV IS NULL           THEN 1 ELSE 0 END AS IDORIG_N_INFO,
                       CASE WHEN SEA.NRSOLISERV = SOR.NRSOLISERV  THEN 1 ELSE 0 END AS IDORIG_IGUAL_ENVARQ,
                       CASE WHEN SEA.CDPRODGRUP <> SOR.CDPRODGRUP OR PCE.NMPRODUTO <> PCO.NMPRODUTO THEN 1 ELSE 0 END AS IDORIG_DIF_ENVARQ,
                       CASE WHEN SOR.NRSOLISERV IS NULL           THEN '- Solicitação origem NÃO INFORMADA'||chr(10) ELSE '' END ||
                       CASE WHEN SEA.NRSOLISERV = SOR.NRSOLISERV  THEN '- Número solic. origem IGUAL à solic. envio de arquivos'||chr(10) ELSE '' END ||
                       CASE WHEN SEA.CDPRODGRUP <> SOR.CDPRODGRUP THEN '- Versão solic. origem DIFERENTE da versão da solic. envio de arquivos'||chr(10) ELSE '' END ||
                       CASE WHEN PCE.NMPRODUTO <> PCO.NMPRODUTO   THEN '- Produto solic. origem DIFERENTE da versão da solic. envio de arquivos'||chr(10) ELSE '' END AS OBSERVACAO,                       
                       CEA.NMFANTCLIE, CEA.NMRAZSOCCLIE, FEA.NMFASETRAM
                  FROM SOLISERV SEA, CLIENTE CEA, PRODUTO PGE, PRODUTO PCE, EQUIPETRAB EEA, OPERADOR OEA, RESOURCE_T REA, PERMISSION PEA, LOGFASETRAM LEA, FASETRAM FEA, 
                       SOLISERV SOR, CLIENTE COR, PRODUTO PGO, PRODUTO PCO, FASETRAM FSO, ORGANIZACAO ORG
                 WHERE SEA.CDASSUNTO = '01800'
                   AND SEA.IDSOLIENCE <> 'S'
                   AND CEA.CDCLIENTE = SEA.CDCLIENTE
                   AND ORG.NRPARCNEGOCIO(+) = CEA.NRPARCNEGOCIO
                   AND PGE.CDPRODUTO = SEA.CDPRODGRUP
                   AND PCE.CDPRODUTO = SEA.CDPRODCOMP
                   AND EEA.CDEQUIPETRAB = PCE.CDEQUIPERESP
                   AND OEA.CDOPERADOR = EEA.CDOPERRESP
                   AND REA.ORGANIZATION = OEA.NRORG
                   AND REA.EXTERNAL_CODE = OEA.CDOPERADOR
                   AND PEA.ORGANIZATION = REA.ORGANIZATION
                   AND PEA.RESOURCE_T = REA.ID
                   AND NVL(PEA.TYPE, 'R') = 'R'   
                   AND LEA.CDFILIAL = SEA.CDFILIAL
                   AND LEA.NRSOLISERV = SEA.NRSOLISERV
                   AND FEA.CDFASETRAM(+) = SEA.CDFASETRAM
                   AND LEA.DTALFASETRAM = (SELECT MAX(L.DTALFASETRAM)
                                             FROM LOGFASETRAM L 
                                            WHERE L.CDFILIAL = SEA.CDFILIAL
                                              AND L.NRSOLISERV = SEA.NRSOLISERV)
                   AND SOR.CDFILIAL(+) = SEA.CDFILIAL
                   AND SOR.NRSOLISERV(+) = SEA.NRSOLIORIG
                   AND (SEA.CDFASETRAM <> '101' OR SOR.CDFASETRAM <> '101')
                   AND COR.CDCLIENTE(+) = SOR.CDCLIENTE
                   AND PGO.CDPRODUTO(+) = SOR.CDPRODGRUP
                   AND PCO.CDPRODUTO(+) = SOR.CDPRODCOMP
                   AND FSO.CDFASETRAM(+) = SOR.CDFASETRAM)
            WHERE 1 = 1
            $filters
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }
    
}